import React, { useEffect } from 'react';
import { AppRegistry } from 'react-native';
import { matchRoutes } from 'react-router-config';
import { ApplyPluginsType, Router } from 'umi-react-native-runtime';
import { renderRoutes } from './renderRoutes';
function RouterComponent(_a) {
    var history = _a.history, plugin = _a.plugin, routes = _a.routes;
    useEffect(function () {
        function routeChangeHandler(location, action) {
            var matchedRoutes = matchRoutes(routes, location.pathname);
            plugin.applyPlugins({
                key: 'onRouteChange',
                type: ApplyPluginsType.event,
                args: {
                    routes: routes,
                    matchedRoutes: matchedRoutes,
                    location: location,
                    action: action,
                },
            });
        }
        routeChangeHandler(history.location, 'POP');
        return history.listen(routeChangeHandler);
    }, [history, plugin, routes]);
    return React.createElement(Router, { history: history }, renderRoutes(routes));
}
export function renderClient(_a) {
    var history = _a.history, routes = _a.routes, plugin = _a.plugin, appKey = _a.appKey;
    var App = plugin.applyPlugins({
        type: ApplyPluginsType.modify,
        key: 'rootContainer',
        initialValue: React.createElement(RouterComponent, { history: history, routes: routes, plugin: plugin }),
        args: {
            history: history,
            routes: routes,
            plugin: plugin,
        },
    });
    AppRegistry.registerComponent(appKey, function () { return function () { return App; }; });
    return App;
}
//# sourceMappingURL=index.js.map